//Last version:20/04/2018 
//Reads learning and testing data fom root ntuple files and writes output data into a ntuple file.
//problemheading      your mame of the problem
//ntlrnfile, ntlrn    file and name of the ntuple containing the learning set
//nttstfile, nttst    file and name of the ntuple containing the testing set.
//		      The testing set need not contain a class number (0, 1)
//ntoutfile, ntout    file and name of the ntuple containing probabilities of class 0 and class 1.
//
#include "stdio.h"
#include "MyRoot.h"
#include "iinc.h"
#include "TFile.h"
#include "TNtuple.h"

void ntiinc(char* problemheading, char* ntlrnfile, char* ntlrn, char* nttstfile, char* nttst, char* ntoutfile, char* ntout){
//Reads learning and testing data fom root ntuple files and writes output data into a ntuple file.
//problemheading      your mame of the problem
//ntlrnfile, ntlrn    file and name of the ntuple containing the learning set
//nttstfile, nttst    file and name of the ntuple containing the testing set.
//		      The testing set need not contain a class number (0, 1)
//ntoutfile, ntout    file and name of the ntuple containing probabilities of class 0 and class 1.
//
	long rows[1], cols[1], rowst[1], colst[1], i, j, Count[2];
	char d[255];
findntarraysize(ntlrnfile, ntlrn, rows, cols);
findntarraysize(nttstfile, nttst, rowst,colst);
double *LRN = new double[rows[0]*cols[0]];
double *TST = new double[rowst[0]*colst[0]];
double *weit = new double[rows[0]];//array of samples weights
double *Probab = new double[rowst[0]*2];
Count[0]=0;
Count[1]=0;
j=LRN[cols[0]-1];
//declare and fill-in Count array:
for(i=0;i<rows[0];i++){ 
	weit[i]=1.0;
	if(j==LRN[i*cols[0]+cols[0]-1]) Count[0]+=1;
	else Count[1]+=1;
}
//fill-in LRN and TST arrays:
ntfileTOarray(ntlrnfile, ntlrn, LRN, rows[0], cols[0]);
ntfileTOarray(nttstfile, nttst, TST, rowst[0],colst[0]);

//call iinc with all defaults; 2 classes only (separation)
i = iincbase(LRN, TST, Probab, cols[0]-1, 2, rows[0], rowst[0], cols[0]-colst[0], 
	-12, 0, 0, 2, 0, 0, Count, weit, 0, strcpy(d,"iinc"), 0);

//write output array to ntuplefile
arrayTOntfile(Probab, rowst[0], 2, ntoutfile, ntout, problemheading, strcpy(d,"probality0:probability1"));
}
